#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#define bufsiz 1024
#define elementsof(a) (sizeof(a)/sizeof((a)[0]))
unsigned char buf[bufsiz];
jmp_buf jmpbuf;
long len, cnt;
int trk, maxtrk;

char name[12][3]={"C ","C#","D ","D#","E ","F ","F#","G ","G#","A ","A#","B "};

char *tone[128]={
/* 00 */ "GM pf grand piano   LA acou piano 1 PCM a piano 1  ",
/* 01 */ "GM pf bright piano  LA acou piano 2 PCM a piano 2  ",
/* 02 */ "GM pf electricGrand LA acou piano 3 PCM a piano 3  ",
/* 03 */ "GM pf honky-tonk p. LA elec piano 1 PCM a piano 4  ",
/* 04 */ "GM pf e-piano 1     LA elec piano 2 PCM a piano 5  ",
/* 05 */ "GM pf e-piano 2     LA elec piano 3 PCM a piano 7  ",
/* 06 */ "GM pf harpsichord   LA elec piano 4 PCM a piano 9  ",
/* 07 */ "GM pf clavichord    LA honkytonk p. PCM e piano 1  ",
/* 08 */ "GM cr celesta       LA elec organ 1 PCM e piano 3  ",
/* 09 */ "GM cr grockenspiel  LA elec organ 2 PCM e piano 5  ",
/* 0a */ "GM cr musix box     LA elec organ 3 PCM a guiter 1 ",
/* 0b */ "GM cr vibraphone    LA elec organ 4 PCM a guiter 3 ",
/* 0c */ "GM cr marimba       LA pipe organ 1 PCM a guiter 4 ",
/* 0d */ "GM cr xylophone     LA pipe organ 2 PCM e guiter 1 ",
/* 0e */ "GM cr tubuler bell  LA pipe organ 3 PCM e guiter 2 ",
/* 0f */ "GM cr dulcimer      LA accordion    PCM slap  3    ",
/* 10 */ "GM o drawbar organ  LA harpsichord1 PCM slap  4    ",
/* 11 */ "GM o electric organ LA harpsichord2 PCM slap  5    ",
/* 12 */ "GM o rock organ     LA harpsichord3 PCM slap  6    ",
/* 13 */ "GM o church organ   LA clavichord 1 PCM slap  9    ",
/* 14 */ "GM o reed organ     LA clavichord 2 PCM slap 10    ",
/* 15 */ "GM o accordion      LA clavichord 3 PCM slap 11    ",
/* 16 */ "GM o harmonica      LA celesta 1    PCM slap 12    ",
/* 17 */ "GM o bandneon       LA celesta 2    PCM fingered 1 ",
/* 18 */ "GM g nylon guiter   LA syn. brass 1 PCM fingered 2 ",
/* 19 */ "GM g steel guiter   LA syn. brass 2 PCM picked 1   ",
/* 1a */ "GM g jazz guiter    LA syn. brass 3 PCM picked 2   ",
/* 1b */ "GM g clean guiter   LA syn. brass 4 PCM fretless 1 ",
/* 1c */ "GM g muted guiter   LA synth bass 1 PCM ac bass 1  ",
/* 1d */ "GM g overdriven gt. LA synth bass 2 PCM choir 1    ",
/* 1e */ "GM g distortion gt. LA synth bass 3 PCM choir 2    ",
/* 1f */ "GM g gt. harmonics  LA synth bass 4 PCM choir 3    ",
/* 20 */ "GM bs acoustic bass LA fantasy      PCM choir 4    ",
/* 21 */ "GM bs fingered bass LA harmo pan    PCM strings 1  ",
/* 22 */ "GM bs picked bass   LA chorale      PCM strings 2  ",
/* 23 */ "GM bs fretless bass LA glasses      PCM strings 3  ",
/* 24 */ "GM bs slap bass 1   LA soundtrack   PCM strings 4  ",
/* 25 */ "GM bs slap bass 2   LA atmosphere   PCM e organ  2 ",
/* 26 */ "GM bs synth bass 1  LA warm bell    PCM e organ  4 ",
/* 27 */ "GM bs synth bass 2  LA funny vox    PCM e organ  6 ",
/* 28 */ "GM st violin        LA echo bell    PCM e organ  8 ",
/* 29 */ "GM st viola         LA ice rain     PCM e organ  9 ",
/* 2a */ "GM st cello         LA oboe 2001    PCM e organ 10 ",
/* 2b */ "GM st contrabass    LA echo pan     PCM e organ 11 ",
/* 2c */ "GM st tremolo str.  LA doctor solo  PCM e organ 12 ",
/* 2d */ "GM st pizzicato str LA school daze  PCM e organ 13 ",
/* 2e */ "GM st harp          LA bell singer  PCM soft tp 1  ",
/* 2f */ "GM st timpani       LA square wave  PCM soft tp 3  ",
/* 30 */ "GM en str ensemble  LA str section1 PCM tp/trb 1   ",
/* 31 */ "GM en slow str ens  LA str section2 PCM tp/trb 2   ",
/* 32 */ "GM en synth str 1   LA str section3 PCM tp/trb 3   ",
/* 33 */ "GM en synth str 2   LA pizzicate    PCM tp/trb 4   ",
/* 34 */ "GM en choir aahs    LA violin 1     PCM tp/trb 5   ",
/* 35 */ "GM en voice oohs    LA violin 2     PCM tp/trb 6   ",
/* 36 */ "GM en synth voice   LA cello 1      PCM sax 1      ",
/* 37 */ "GM en ohchestra hit LA cello 2      PCM sax 2      ",
/* 38 */ "GM Br trumpet       LA contrabass   PCM sax 3      ",
/* 39 */ "GM Br trombone      LA harp 1       PCM sax 5      ",
/* 3a */ "GM Br tuba          LA harp 2       PCM brass 1    ",
/* 3b */ "GM Br muted trumpet LA guiter 1     PCM brass 2    ",
/* 3c */ "GM Br french horn   LA guiter 2     PCM brass 3    ",
/* 3d */ "GM Br brass section LA elec guiter1 PCM brass 4    ",
/* 3e */ "GM Br synth brass 1 LA elec guiter2 PCM brass 5    ",
/* 3f */ "GM Br synth brass 2 LA sitar        PCM ohche hit  ",
/* 40 */ "GM lead soprano sax LA acou bass 1  PCM harpsichord",
/* 41 */ "GM lead alto sax    LA acou bass 2  PCM coupled hps",
/* 42 */ "GM lead tenor sax   LA elec bass 1  PCM church org1",
/* 43 */ "GM lead baritoneSax LA elec bass 2  PCM church org2",
/* 44 */ "GM lead oboe        LA slap bass 1  PCM tinkle bell",
/* 45 */ "GM lead englishHorn LA slap bass 2  PCM steel drums",
/* 46 */ "GM lead bassoon     LA fretless 1   PCM celesta    ",
/* 47 */ "GM lead clarinet    LA fretless 2   PCM sitar      ",
/* 48 */ "GM pipe piccolo     LA flute 1      PCM santur     ",
/* 49 */ "GM pipe flute       LA flute 2      PCM koto       ",
/* 4a */ "GM pipe recorder    LA piccolo 1    PCM pan flute  ",
/* 4b */ "GM pipe pan flute   LA piccolo 2    PCM piano 3    ",
/* 4c */ "GM pipe bottle blow LA recorder     PCM clav       ",
/* 4d */ "GM pipe shakuhachi  LA pan pipes    PCM violin 1   ",
/* 4e */ "GM pipe whistle     LA sax 1        PCM violin 2   ",
/* 4f */ "GM pipe ocarina     LA sax 2        PCM cello 1    ",
/* 50 */ "GM sl square wave   LA sax 3        PCM cello 2    ",
/* 51 */ "GM sl sawtooth wave LA sax 4        PCM contrabass ",
/* 52 */ "GM sl syn calliope  LA clarinet 1   PCM pizzicate  ",
/* 53 */ "GM sl chiffer lead  LA clarinet 2   PCM harp       ",
/* 54 */ "GM sl charang       LA oboe         PCM oboe 1     ",
/* 55 */ "GM sl solo vox      LA english horn PCM oboe 2     ",
/* 56 */ "GM sl 5th saw wave  LA bassoon      PCM bassoon 1  ",
/* 57 */ "GM sl bass & lead   LA harmonica    PCM bassoon 2  ",
/* 58 */ "GM sp fantasia pad  LA trumpet 1    PCM clarinet 1 ",
/* 59 */ "GM sp warm pad      LA trumpet 2    PCM clarinet 2 ",
/* 5a */ "GM sp polysynth pad LA trombone 1   PCM clarinet 3 ",
/* 5b */ "GM sp space voice   LA trombone 2   PCM fr horn 1  ",
/* 5c */ "GM sp bowed glass   LA french horn1 PCM fr horn 2  ",
/* 5d */ "GM sp metalic pad   LA french horn2 PCM fr horn 3  ",
/* 5e */ "GM sp halo pad      LA tuba         PCM tuba 1     ",
/* 5f */ "GM sp sweep pad     LA brass sect 1 PCM tuba 2     ",
/* 60 */ "GM s-fx1 ice rain   LA brass sect 2 PCM timpani    ",
/* 61 */ "GM s-fx2 soundtrack LA vibe 1       PCM jazz gt.   ",
/* 62 */ "GM s-fx3 crystal    LA vibe 2       PCM hawaiian gt",
/* 63 */ "GM s-fx4 atmosphere LA syn mallet   PCM muted gt.  ",
/* 64 */ "GM s-fx5 brightness LA windbell     PCM chorus gt. ",
/* 65 */ "GM s-fx6 goblins    LA glock        PCM overdrive g",
/* 66 */ "GM s-fx7 echo drops LA tube bell    PCM distortion ",
/* 67 */ "GM s-fx8 star theme LA xylophone    PCM feedback gt",
/* 68 */ "GM ethnic siter     LA marimba      PCM g harmonics",
/* 69 */ "GM ethnic banjo     LA koto         PCM fantasia   ",
/* 6a */ "GM ethnic shamisen  LA sho          PCM space voice",
/* 6b */ "GM ethnic koto      LA shakuhachi   PCM solo vox   ",
/* 6c */ "GM ethnic kalimba   LA whistle 1    PCM metal pad  ",
/* 6d */ "GM ethnic bag pipe  LA whistle 2    PCM syn brass 1",
/* 6e */ "GM ethnic fiddle    LA bottle blow  PCM synstrings1",
/* 6f */ "GM ethnic shannai   LA breathpipe   PCM synstrings2",
/* 70 */ "GM pr tinkle bell   LA timpani      PCM e.piano 2  ",
/* 71 */ "GM pr agogo         LA melodic tom  PCM detuned ep2",
/* 72 */ "GM pr steel drums   LA deep snare   PCM syn vox    ",
/* 73 */ "GM pr woodblock     LA elec perc 1  PCM syn bass 1 ",
/* 74 */ "GM pr taiko drum    LA elec perc 2  PCM syn bass 2 ",
/* 75 */ "GM pr melodic tom   LA taiko        PCM syn bass 3 ",
/* 76 */ "GM pr synth drum    LA taiko rim    PCM syn bass 4 ",
/* 77 */ "GM pr reverseCymbal LA cymbal       PCM syn brass 2",
/* 78 */ "GM sfx fret noize   LA castanets    PCM organ 3    ",
/* 79 */ "GM sfx breath noize LA triangle     PCM alto sax   ",
/* 7a */ "GM sfx sea-shore    LA orche hit    PCM tenor sax  ",
/* 7b */ "GM sfx bird tweet   LA telephone    PCM baritoneSax",
/* 7c */ "GM sfx telephone    LA bird tweet   PCM trombone   ",
/* 7d */ "GM sfx helicopter   LA one note jam PCM melo tom   ",
/* 7e */ "GM sfx applause     LA water bells  PCM synth drum ",
/* 7f */ "GM sfx gun shot     LA jungle tune  PCM 808 tom    ",
};

char *maker[128]={
/* 00 */ "",
/* 01 */ "Sequential",
/* 02 */ "IDP   ",
/* 03 */ "Voyetra/Octave-Plateau",
/* 04 */ "MOOG  ",
/* 05 */ "Passport Design",
/* 06 */ "Lexicon",
/* 07 */ "Kurzwail",
/* 08 */ "Fender",
/* 09 */ "Gulbransen",
/* 0a */ "AKG Acoustic",
/* 0b */ "Voyce Music",
/* 0c */ "WaveFrame Corp",
/* 0d */ "ADA Signal Processors",
/* 0e */ "Garfield Electronics",
/* 0f */ "Ensoniq",
/* 10 */ "Oberheim",
/* 11 */ "Apple computer",
/* 12 */ "Gray Matter Response",
/* 13 */ "Mimetics",
/* 14 */ "Palm Tree Instruments",
/* 15 */ "JL Cooper",
/* 16 */ "Lowrey",
/* 17 */ "Adams-Smith",
/* 18 */ "E-mu Systems",
/* 19 */ "Harmony Systems",
/* 1a */ "ART   ",
/* 1b */ "Baldwin",
/* 1c */ "Eventide",
/* 1d */ "Inventronics",
/* 1e */ "Key Concepts",
/* 1f */ "Clarity",

/* 20 */ "Passac",
/* 21 */ "SIEL  ",
/* 22 */ "Synthaxe",
/* 23 */ "Stepp ",
/* 24 */ "Hohner",
/* 25 */ "Twister",
/* 26 */ "Solton",
/* 27 */ "Jellinghaus MS",
/* 28 */ "Southworth Music Systems",
/* 29 */ "oof",
/* 2a */ "idm",
/* 2b */ "SSL Limited",
/* 2c */ "Audio Vertriebe-Peter Struven",
/* 2d */ "Neve  ",
/* 2e */ "Soundtracs Ltd",
/* 2f */ "Elka  ",
/* 30 */ "Dynacord",
/* 31 */ "Intercont Electronics",
/* 32 */ "Drawmen",
/* 33 */ "Clavia Digital Inst",
/* 34 */ "Ziklus Limited",
/* 35 */ "General Electronics Music Corp.",
/* 36 */ "Chetah Marketing",
/* 37 */ "C.T.M.",
/* 38 */ "Simmons UK",
/* 39 */ "Soundcraft Electronics",
/* 3a */ "Steinberg Digital Audio",
/* 3b */ "Wersi ",
/* 3c */ "Aveb Electronik Ab",
/* 3d */ "Digigram",
/* 3e */ "Waldorf",
/* 3f */ "Quasimidi",

/* 40 */ "Kawaii",
/* 41 */ "Roland",
/* 42 */ "Korg  ",
/* 43 */ "Yamaha",
/* 44 */ "Casio ",
/* 45 */ "?(Japan)",
/* 46 */ "Kamiya Studio",
/* 47 */ "Akai  ",
/* 48 */ "Japan Victor",
/* 49 */ "n",
/* 4a */ "y",
/* 4b */ "Fujitsu",
/* 4c */ "Sony  ",
/* 4d */ "Lg쏊(Maxon)",
/* 4e */ "TEAC  ",
/* 4f */ "޸",
/* 50 */ "Matusita electric",
/* 51 */ "Fostex",
/* 52 */ "ZOOM",
/* 53 */ "Midori Erectronics",
/* 54 */ "RAMSA(Matusita Communication Industrial)",
/* 55 */ "Suzuki Musical Inst Mfg",
/* 56 */ "",
/* 57 */ "",
/* 58 */ "",
/* 59 */ "",
/* 5a */ "",
/* 5b */ "",
/* 5c */ "",
/* 5d */ "",
/* 5e */ "",
/* 5f */ "",
/* 60 */ "",
/* 61 */ "",
/* 62 */ "",
/* 63 */ "",
/* 64 */ "",
/* 65 */ "",
/* 66 */ "",
/* 67 */ "",
/* 68 */ "",
/* 69 */ "",
/* 6a */ "",
/* 6b */ "",
/* 6c */ "",
/* 6d */ "",
/* 6e */ "",
/* 6f */ "",
/* 70 */ "",
/* 71 */ "",
/* 72 */ "",
/* 73 */ "",
/* 74 */ "",
/* 75 */ "",
/* 76 */ "",
/* 77 */ "",
/* 78 */ "",
/* 79 */ "",
/* 7a */ "",
/* 7b */ "",
/* 7c */ "",
/* 7d */ "univ:academic",
/* 7e */ "univ:non-realtime",
/* 7f */ "univ:realtime",
};

char *submaker[]={
/* 00 */ "",
/* 01 */ "Symetric",
/* 02 */ "Music Logic Systems",
/* 03 */ "PAIA",
/* 04 */ "Othertech",
/* 05 */ "K-Muse",
/* 06 */ "Stypher",
/* 07 */ "Digital Music Corp",
/* 08 */ "IOTA Systems",
/* 09 */ "New England Digitals",
/* 0a */ "Artisyn",
/* 0b */ "IVL Technologies",
/* 0c */ "Southern Music Systems",
/* 0d */ "Lake Butler Sound",
/* 0e */ "Alesis",
/* 0f */ "Sound Creation",
/* 10 */ "DOD Electronics",
/* 11 */ "Integrated Media Systems",
/* 12 */ "Sonus",
/* 13 */ "Temporal Acuity Products",
/* 14 */ "Jeff Tripp/Perfect Fretworks",
/* 15 */ "KAT",
/* 16 */ "Opcode",
/* 17 */ "Rane Corp",
/* 18 */ "Spatial Sound/Anadi inc.",
/* 19 */ "KMX(Ken Yprilla)",
/* 1a */ "Allen & Heath Brenell",
/* 1b */ "Peavy Electronics",
/* 1c */ "360 Systems",
/* 1d */ "Wenger Corp",
/* 1e */ "Marquis Music",
/* 1f */ "Zeta Systems",
/* 20 */ "Axxes(Brian Personett)",
/* 21 */ "Orban",
/* 22 */ "Indian Valley Mnfg",
/* 23 */ "Triton",
/* 24 */ "KTI",
/* 25 */ "Breakaway Technologies",
/* 26 */ "CAE",
/* 27 */ "Harrison Systems Inc",
/* 28 */ "Future Lab/Mark Ku",
/* 29 */ "Rocktron Corp",
/* 2a */ "PianoDisc",
/* 2b */ "Cannon Research Group",
/* 2c */ "",
/* 2d */ "Rodgers Instrument Corp",
/* 2e */ "Blue Sky Logic",
/* 2f */ "Encore Erectronics",
/* 30 */ "Uptown",
/* 31 */ "Voce",
/* 32 */ "",
/* 33 */ "S&S Research",
/* 34 */ "Broderbund Software Inc",
/* 35 */ "Allen Organ Co",
/* 36 */ "",
/* 37 */ "",
/* 38 */ "APHEX",
/* 39 */ "Gallien Krueger",
/* 3a */ "IBM",
/* 3b */ "",
/* 3c */ "Hotz Instruments Technologies",
/* 3d */ "ETA Lighting",
/* 3e */ "NSI Corp",
/* 3f */ "Ad Lib Inc",
/* 40 */ "Richmond Sound Design",
/* 41 */ "Microsoft",
/* 42 */ "The Software Toolworks(Anne Graham)",
/* 43 */ "RJMG/Niche",
/* 44 */ "Intone",
/* 45 */ "",
/* 46 */ "",
/* 47 */ "GT Electronics/Groove Tubes",
/* 48 */ "",
/* 49 */ "",
/* 4a */ "",
/* 4b */ "",
/* 4c */ "",
/* 4d */ "",
/* 4e */ "",
/* 4f */ "Mackie",
/* 50 */ "",
/* 51 */ "",
/* 52 */ "",
/* 53 */ "",
/* 54 */ "",
/* 55 */ "Lone Worf",
/* 56 */ "",
/* 57 */ "",
/* 58 */ "",
/* 59 */ "",
/* 5a */ "",
/* 5b */ "",
/* 5c */ "",
/* 5d */ "",
/* 5e */ "",
/* 5f */ "",
/* 60 */ "",
/* 61 */ "",
/* 62 */ "",
/* 63 */ "",
/* 64 */ "Musonix",
};
char *eurmaker[]={
/* 00 */ "Dream",
/* 01 */ "Strand Lighting",
/* 02 */ "Amek Systems Ltd",
/* 03 */ "",
/* 04 */ "Dr Bohm/Musican International",
/* 05 */ "",
/* 06 */ "Trident Audio",
/* 07 */ "Real World Studio",
/* 08 */ "",
/* 09 */ "",
/* 0a */ "Audiomatica",
/* 0b */ "",
/* 0c */ "",
/* 0d */ "",
/* 0e */ "",
/* 0f */ "Bontempi/Farfisa",
};

char *drums[]={
/* 27 */ "(GS) High Q",
/* 28 */ "(GS) Slap",
/* 29 */ "(GS) Scratch Push",
/* 30 */ "(GS) Scratch Pull",
/* 31 */ "(GS) Sticks",
/* 32 */ "(GS) Square Click",
/* 33 */ "(GS) Metronome Click",
/* 34 */ "(GS) Metronome Bell",
/* 35 */ "(GM) Acoustic Bass Drum",
/* 36 */ "(GM) Bass Drum 1",
/* 37 */ "(GM) Side Stick",
/* 38 */ "(GM) Acoustic Snare",
/* 39 */ "(GM) Hand Clap",
/* 40 */ "(GM) Electric Snare",
/* 41 */ "(GM) Low Floor Tom",
/* 42 */ "(GM) Closed Hi-Hat",
/* 43 */ "(GM) High Floor Tom",
/* 44 */ "(GM) Pedal Hi-Hat",
/* 45 */ "(GM) Low Tom",
/* 46 */ "(GM) Open Hi-Hat",
/* 47 */ "(GM) Low-Mid Tom",
/* 48 */ "(GM) Hi-Mid Tom",
/* 49 */ "(GM) Crash Cymbal 1",
/* 50 */ "(GM) High Tom",
/* 51 */ "(GM) Ride Cymbal 1",
/* 52 */ "(GM) Chinese Cymbal",
/* 53 */ "(GM) Ride Bell",
/* 54 */ "(GM) Tambourine",
/* 55 */ "(GM) Splash Cymbal",
/* 56 */ "(GM) Cowbell",
/* 57 */ "(GM) Crash Cymbal 2",
/* 58 */ "(GM) Vibraslap",
/* 59 */ "(GM) Ride Cymbal 2",
/* 60 */ "(GM) Hi Bongo",
/* 61 */ "(GM) Low Bongo",
/* 62 */ "(GM) Mute Hi Conga",
/* 63 */ "(GM) Open Hi Conga",
/* 64 */ "(GM) Low Conga",
/* 65 */ "(GM) High Timbale",
/* 66 */ "(GM) Low Timbale",
/* 67 */ "(GM) High Agogo",
/* 68 */ "(GM) Low Agogo",
/* 69 */ "(GM) Cabasa",
/* 70 */ "(GM) Maracas",
/* 71 */ "(GM) Short Whistle",
/* 72 */ "(GM) Long Whistle",
/* 73 */ "(GM) Short Guiro",
/* 74 */ "(GM) Long Guirl",
/* 75 */ "(GM) Clavas",
/* 76 */ "(GM) Hi Wood Block",
/* 77 */ "(GM) Low Wood Block",
/* 78 */ "(GM) Mute Cuica",
/* 79 */ "(GM) Open Cuica",
/* 80 */ "(GM) Mute Triangle",
/* 81 */ "(GM) Open Triangle (GM)",
/* 82 */ "(GS) Shaker",
/* 83 */ "(GS) Jingle Bell",
/* 84 */ "(GS) Belltree",
/* 85 */ "(GS) Castanets",
/* 86 */ "(GS) Mute Surdo",
/* 87 */ "(GS) Open Surdo",
/* 88 */ "(LA) Car-Stop",
/* 89 */ "(LA) Car-Pass",
/* 90 */ "(LA) Crash",
/* 91 */ "(LA) Siren",
/* 92 */ "(LA) Train",
/* 93 */ "(LA) Jet",
/* 94 */ "(LA) Helicopter",
/* 95 */ "(LA) Starship",
/* 96 */ "(LA) Pistol",
/* 97 */ "(LA) Machine Gun",
/* 98 */ "(LA) Lasergun",
/* 99 */ "(LA) Explosion",
/*100 */ "(LA) Dog",
/*101 */ "(LA) Horse",
/*102 */ "(LA) Birds",
/*103 */ "(LA) Rain",
/*104 */ "(LA) Thunder",
/*105 */ "(LA) Wind",
/*106 */ "(LA) Wave",
/*107 */ "(LA) Stream",
/*108 */ "(LA) Bubble",
};



int byteread(FILE *fp){
	int c;
	c=fgetc(fp);
	cnt++;
	if (cnt>len){
		printf("---------- track %d end\n",trk);trk++;
		if (trk<maxtrk)ungetc(c,fp),longjmp(jmpbuf,1);
	}
	return c;
}

int note_on(int c, FILE *fp){
	int k=c,n,p;
	printf(" k=x%2x",c);
	c=byteread(fp);printf(" v=x%2x ",c);
	n=k % 12;  /* key=69 ... 440Hz */
	p=k / 12 - 1;
	printf(" %s%d",name[n],p);
	return c;
}
int cont_ch(int c, FILE *fp){
	int p=c;
	printf(" p=%3d",c);
	c=byteread(fp);printf(" v=%3d ",c);
	switch(p){
	case  0:case 32:printf("bankselect(gs,xg)");
		if (p==32 && c==0) printf(" sc88 default");
		if (p==32 && c==1) printf(" sc88 55-map");
		if (p==32 && c==2) printf(" sc88 88-map");
		if (p==0 && c== 0) printf(" mu80 normal");
		if (p==0 && c==64) printf(" mu80 sfx");
		if (p==0 && c==126) printf(" mu80 dramm or gs:cm-64");
		if (p==0 && c==127) printf(" mu80 dramm or gs:mt-32");
		break;
	case  1:case 33:printf("modulation(gm)");break;
	case  2:case 34:printf("bress cont");break;
	case  3:case 35:printf("          ");break;
	case  4:case 36:printf("foot contr");break;
	case  5:case 37:printf("portam tim(gs,xg)");break;
	case  6:case 38:printf("data entry(gm)");break;
	case  7:case 39:printf("main volum(gm)");break;
	case  8:case 40:printf("balance   ");break;
	case  9:case 41:printf("          ");break;
	case 10:case 42:printf("pan pot   (gm)");break;
	case 11:case 43:printf("expresion (gm)");break;
	case 12:case 44:printf("effect_c_1");break;
	case 13:case 45:printf("effect_c_2");break;
	case 16:case 48:printf("ėp_1");break;
	case 17:case 49:printf("ėp_2");break;
	case 18:case 50:printf("ėp_3");break;
	case 19:case 51:printf("ėp_4");break;
	case 64:printf("hold 1(danper)(gm)");break;
	case 65:printf("portament switch(gs,xg)");break;
	case 66:printf("sono tenuto(gs,xg)");break;
	case 67:printf("soft pedal(gs,xg)");break;
	case 68:printf("Legato");break;
	case 69:printf("hold 2(freeze)");break;
	case 70:printf("Sound Controller #1 (Sound Variation)");break;
	case 71:printf("rezonance(xg) harmonic content");break;
	case 72:printf("Release time(xg)");break;
	case 73:printf("Attack time(xg)");break;
	case 74:printf("cutoff frequency(xg) brightness");break;
	case 80:printf("ėp_5");break;
	case 81:printf("ėp_6");break;
	case 82:printf("ėp_7");break;
	case 83:printf("ėp_8");break;
	case 84:printf("portament control(legart)(gs,xg)");break;
	case 91:printf("reverb(gs,xg)");break;
	case 92:printf("tremoro");break;
	case 93:printf("chorus(gs,xg)");break;
	case 94:printf("delay(gs) variation(xg) cereste");break;
	case 95:printf("phaser");break;
	case 96:printf("data++(xg)");break;
	case 97:printf("data--(xg)");break;
	case 98: printf("NRPN:LSB");
		if (c==0x08) printf(" vibrate rate(gs,xg)");
		if (c==0x09) printf(" vibrate depth(gs,xg)");
		if (c==0x0a) printf(" vibrate delay(gs,xg)");
		if (c==0x20) printf(" tvf cutoff frequency(gs,xg)");
		if (c==0x21) printf(" tvf resonance(gs,xg)");
		if (c==0x63) printf(" tvf tva attack time(gs,xg)");
		if (c==0x64) printf(" tvf tva decay time(gs,xg)");
		if (c==0x66) printf(" tvf tva release time(gs,xg)");
		break;
	case 99: printf("NRPN:MSB");
		if (c==0x01) printf(" gs edit");
		if (c==0x14) printf(" drums cutoff frequency(xg)");
		if (c==0x15) printf(" drums rezonance(xg)");
		if (c==0x16) printf(" drums EG attack(xg)");
		if (c==0x17) printf(" drums EG dekay(xg)");
		if (c==0x18) printf(" drums pitch(gs,xg)");
		if (c==0x19) printf(" drums pitch fine(xg)");
		if (c==0x1a) printf(" drums tva(gs,xg)");
		if (c==0x1c) printf(" drums pan(gs,xg)");
		if (c==0x1d) printf(" drums reverb send level(gs,xg)");
		if (c==0x1e) printf(" drums chorus send level(xg)");
		if (c==0x1f) printf(" drums variation send level(xg)");
		break;
	case 100: printf("RPN:LSB");
		if (c==0) printf(" pitch_bend_sencitivity(gm)");
		if (c==1) printf(" fine_tuning(gm)");
		if (c==2) printf(" course_tuning(gm)");
		if (c==127) printf(" RPN null");
		break;
	case 101: printf("RPN:MSB");
		if (c==0) printf(" gm edit");
		if (c==127) printf(" RPN null");
		break;
	case 120: printf("mode message:all sound off(gm)");break;
	case 121: printf("mode message:reset all controlers(gm)");break;
	case 122: printf("mode message:local control");
		if (c==0) printf(" off");
		else      printf(" on");
		break;
	case 123: printf("mode message:all note off(gm)");break;
	case 124: printf("mode message:omni mode off(gs)");break;
	case 125: printf("mode message:omni mode on(gs)");break;
	case 126: printf("mode message:mono mode on(gs) channel=%d",c);break;
	case 127: printf("mode message:pori mode on(gs)");break;
	default:printf("`");break;
	}
	if ( 0==p )        printf(" (GS)");
	if ( 1<=p && p<=31)printf("(MSB)");
	if (32<=p && p<=63)printf("(LSB)");
	return c;
}
int prog_ch(int c, FILE *fp){
	printf(" p=%3d",c);
	printf(" %s",tone[c]);
	return c;
}
int ch_pres(int c, FILE *fp){
	printf(" v=%d",c);
	return c;
}
int pitch_b(int c, FILE *fp){
	int cb = c;
	printf(" l=x%2x",c);
	c=byteread(fp);printf(" m=x%2x",c);
	printf(" ;bend=%d",cb+128*c-8192);
	return c;
}
int f0_stat(int c, FILE *fp){
	int i,l;
	printf(" l=%d",c);l=c;
	for (i=0;i<l;++i) {
		c=byteread(fp); printf(" %2x",c);
		if (i<bufsiz) buf[i]=c;
	}
	if (buf[0]!=0) printf(" ;%s ",maker[buf[0]]);
	else if (buf[1]==0x00 && buf[2]<elementsof(submaker)) printf(" ;%s ",submaker[buf[0]]);
	else if (buf[1]==0x20 && buf[2]<elementsof(eurmaker)) printf(" ;%s ",eurmaker[buf[0]]);
	if (buf[0]==0x40){                                           /* Kawaii */
		if (buf[4]==0x08)printf("GMega ");
	}else if (buf[0]==0x41){                                      /* Roland */
		if (buf[1]==0x10 && buf[2]==0x42 && buf[3]==0x11)printf("GS ްv");
		if (buf[1]==0x10 && buf[2]==0x42 && buf[3]==0x12){
			printf("GS ");    /* GS-reset:f0 41 10 42 12 40 00 7f 00 41 f7 */
			if (buf[4]==0x40 && buf[5]==0){
				if (buf[6]==0x7f && buf[7] == 0) printf("reset ");
				if (buf[6]==0x7f && buf[7] == 0x7f) printf("exit ");
				if (buf[6]==0) printf("master tune ");
				if (buf[6]==1) printf("master tune# ");
				if (buf[6]==2) printf("master tune# ");
				if (buf[6]==3) printf("master tune# ");
				if (buf[6]==4) printf("master volume ");
				if (buf[6]==5) printf("master keyshift ");
				if (buf[6]==6) printf("master pan ");
			}else if (buf[4]==0x40 && buf[5]==1){
				if (buf[6]==0) printf("patch name ");
						  /* ޲ػް f0 41 10 42 12 40 01 01 ccc f7*/
				if (0<buf[6] && buf[6]<=16) printf("޲ػް ");
				if (buf[6]==0x30) printf("reverb macro ");
				if (buf[6]==0x31) printf("reverb char ");
				if (buf[6]==0x32) printf("reverb pre-lpf ");
				if (buf[6]==0x33) printf("reverb level ");
				if (buf[6]==0x34) printf("reverb time ");
				if (buf[6]==0x35) printf("reverb feedback ");
				if (buf[6]==0x36) printf("reverb send level ");
				if (buf[6]==0x37) printf("reverb ? ");
				if (buf[6]==0x38) printf("chorus macro ");
				if (buf[6]==0x39) printf("chorus pre-lpf");
				if (buf[6]==0x3a) printf("chorus level");
				if (buf[6]==0x3b) printf("chorus feedback");
				if (buf[6]==0x3c) printf("chorus delay");
				if (buf[6]==0x3d) printf("chorus rate");
				if (buf[6]==0x3e) printf("chorus depth");
				if (buf[6]==0x3f) printf("chorus send level");
				if (buf[6]==0x40) printf("chorus ? ");
			}else if (buf[4]==0x40 && (buf[5]&0xf0)==0x10) {
				if (buf[6]==0x00) printf("bank select ");
				if (buf[6]==0x01) printf("prog change ");
				if (buf[6]==0x02) printf("Rx channel ON/OFF");
				if (buf[6]==0x03) printf("Rx pitch bend ");
				if (buf[6]==0x04) printf("Rx ch-press ");
				if (buf[6]==0x05) printf("Rx prog-ch ");
				if (buf[6]==0x06) printf("Rx cont-ch ");
				if (buf[6]==0x07) printf("Rx poli-press ");
				if (buf[6]==0x08) printf("Rx note-mes ");
				if (buf[6]==0x09) printf("Rx rpn ");
				if (buf[6]==0x0a) printf("Rx nrpn ");
				if (buf[6]==0x0b) printf("Rx mod ");
				if (buf[6]==0x0c) printf("Rx vol ");
				if (buf[6]==0x0d) printf("Rx pan ");
				if (buf[6]==0x0e) printf("Rx exp ");
				if (buf[6]==0x0f) printf("Rx hold ");
				if (buf[6]==0x10) printf("Rx porta ");
				if (buf[6]==0x11) printf("Rx sos ");
				if (buf[6]==0x12) printf("Rx soft ");
				if (buf[6]==0x13) printf("mono/poly  ");
				if (buf[6]==0x14) printf("assign mode ");
				if (buf[6]==0x15) printf("part mode ");
				if (buf[6]==0x16) printf("pitch shift ");
				if (buf[6]==0x17) printf("fine pttch ");
				if (buf[6]==0x19) printf("part level ");
				if (buf[6]==0x1a) printf("vel sence depth ");
				if (buf[6]==0x1b) printf("vel sence offset ");
				if (buf[6]==0x1c) printf("part pan ");
				if (buf[6]==0x1d) printf("key range low ");
				if (buf[6]==0x1e) printf("key range high ");
				if (buf[6]==0x1f) printf("cc1 ");
				if (buf[6]==0x20) printf("cc2 ");
				if (buf[6]==0x21) printf("chorus send level ");
				if (buf[6]==0x22) printf("reverb send level ");
				if (buf[6]==0x30) printf("vib rate");
				if (buf[6]==0x31) printf("vib depth");
				if (buf[6]==0x32) printf("tvf cutoff freq");
				if (buf[6]==0x33) printf("tvf resonance");
				if (buf[6]==0x34) printf("attack ");
				if (buf[6]==0x35) printf("decay ");
				if (buf[6]==0x36) printf("release ");
				if (buf[6]==0x37) printf("vib decay ");
				if (buf[6]>=0x40) printf("scale tuning ");
			}else if (buf[4]==0x40 && (buf[5]&0xf0)>=0x20) {
				if ((buf[6]&0xf0)==0x00) printf("mod ");
				if ((buf[6]&0xf0)==0x10) printf("bend ");
				if ((buf[6]&0xf0)==0x20) printf("caf ");
				if ((buf[6]&0xf0)==0x30) printf("paf ");
				if ((buf[6]&0xf0)==0x40) printf("cc1 ");
				if ((buf[6]&0xf0)==0x50) printf("cc2 ");
			}
			if (buf[4]==0x41) printf("drums setup parameter ");
		}else if (buf[1]==0x10 && buf[2]==0x45 && buf[3]==0x12){
			printf("SC-55");
			if (buf[4]==0x10 && buf[5]==0 && buf[6]==0) printf("t\");
			else printf("dev=%d mod=%d cmd=%d",buf[1],buf[2],buf[3]);
		}else if (buf[1]==0x10 && buf[2]==0x16 && buf[3]==0x12){
			if (buf[4]==0x7f) printf("LA & PCM ");
			else if (buf[4]>=0x50) printf("PCM ");
			else printf("LA ");
			if (buf[4]==0x02) printf("temp area ");
			if (buf[4]==0x03) printf("patch temp area ");
			if (buf[4]==0x04) printf("timbre temp area ");
			if (buf[4]==0x05) printf("patch memory ");
			if (buf[4]==0x08) printf("timbre memory ");
			if (buf[4]==0x10 && buf[5]==0){
				if (buf[6]==0x00) printf("master tume ");
				if (buf[6]==0x01) printf("reverb mode ");
				if (buf[6]==0x02) printf("reverb time ");
				if (buf[6]==0x03) printf("reverb level ");
				if (0x04<=buf[6] && buf[6]<=0x0c) printf("voice reserve ");
				if (0x0d<=buf[6] && buf[6]<=0x15) printf("Rx channel ON/OFF");
				if (buf[6]==0x16) printf("master volume ");
			}else if (buf[4]==0x40){
				if (buf[5]==0x00) printf("timbra write ");
				if (buf[5]==0x01) printf("patch write ");
				if (buf[5]==0x10) printf("result ");
			}else if (buf[4]==0x50){
				printf("reverb switch");
			}else if (buf[4]==0x52){
				if (buf[6]==0x00) printf("master tume ");
				if (buf[6]==0x01) printf("reverb mode ");
				if (buf[6]==0x02) printf("reverb time ");
				if (buf[6]==0x03) printf("reverb level ");
				if (0x04<=buf[6] && buf[6]<=0x09) printf("voice reserve ");
				if (0x0a<=buf[6] && buf[6]<=0x0f) printf("Rx channel ON/OFF");
				if (buf[6]==0x10) printf("master volume ");
			}else if (buf[4]==0x7f) printf("all parameters reset ");
		}else if (buf[2]==0x14){ printf("D-50");
		}else if (buf[2]==0x46){ printf("JV-80");
		}else if (buf[2]==0x4d){ printf("JV-30");
		}else printf("dev=%d mod=%d cmd=%d",buf[1],buf[2],buf[3]);
	}else if (buf[0]==0x42){                                      /* Korg */
		if (buf[2]==0x30) printf("03R/W ");
	}else if (buf[0]==0x43){                                      /* YAMAHA */
		if (buf[2]==0x27) printf("TG100");
		if (buf[2]==0x1b) printf("TG100 SW Remote");
		if (buf[1]==0x10 && buf[2]==0x4c) {
			printf("XG ");
			if (buf[3]==0 && buf[4]==0 && buf[5]==0x7e && buf[6]==0) printf("on");
			/* xg system data parameter change */
			/* multi effect 1 data parameter change */
			/* multi part data parameter change */
			/* drums setup data parameter change*/
		}
	}else if (buf[0]==0x7e){         /* GM-ON : F0 7E 7F 09 01 F7 */
		/*  device_id       sub_id_1     sub_id_2 */
		if (                buf[2]==9             ) printf("GM ");
		if (buf[1]==0x7f && buf[2]==9 && buf[3]==1) printf("on");
		if (buf[1]==0x7f && buf[2]==9 && buf[3]==2) printf("off");
		if (                buf[2]==0x01) printf("sample dump header");
		else if (           buf[2]==0x02) printf("sample data packet");
		else if (           buf[2]==0x03) printf("sample dump request");
		else if (           buf[2]==0x04) {
			printf("MIDI time code (Cueing)");
			if (buf[3]==0x00) printf(":special");
			if (buf[3]==0x01) printf(":panch in point");
			if (buf[3]==0x02) printf(":panch out point");
			if (buf[3]==0x03) printf(":delete panch in point");
			if (buf[3]==0x04) printf(":delete panch out point");
			if (buf[3]==0x05) printf(":event start point");
			if (buf[3]==0x06) printf(":event stop point");
			if (buf[3]==0x07) printf(":event start with additional info");
			if (buf[3]==0x08) printf(":event stop with additional info");
			if (buf[3]==0x09) printf(":delete event start point");
			if (buf[3]==0x0a) printf(":delete event stop point");
			if (buf[3]==0x0b) printf(":cue point");
			if (buf[3]==0x0c) printf(":cue point with additional info");
			if (buf[3]==0x0d) printf(":delete cue point");
			if (buf[3]==0x0e) printf(":event name");
			if (buf[3]==0x0f) printf(":event name in additional info");
			if (buf[9]==0x00) printf("\t:timecode offset");
			if (buf[9]==0x01) printf("\t:enable eventlist");
			if (buf[9]==0x02) printf("\t:disable eventlist");
			if (buf[9]==0x03) printf("\t:clear eventlist");
			if (buf[9]==0x04) printf("\t:system stop");
			if (buf[9]==0x05) printf("\t:event request");
		}else if (          buf[2]==0x05) {
			printf("sample dump extention");
			if (buf[3]==1) printf(":multi loop point");
			if (buf[3]==2) printf(":loop point request");
		}else if (          buf[2]==0x06) {
			printf("general infomation");
			if (buf[3]==1) printf(":identity request");
			if (buf[3]==2) printf(":identity reply");
		}else if (          buf[2]==0x07) { printf("file dump");
			if (            buf[2]==0x07 && buf[3]==0x01) printf("(header)");
			if (            buf[2]==0x07 && buf[3]==0x02) printf("(packet)");
			if (            buf[2]==0x07 && buf[3]==0x03) printf("(request)");
			if (            buf[2]==0x07 && buf[3]==0x7b) printf("(eof)");
			if (            buf[2]==0x07 && buf[3]==0x7c) printf("(wait)");
			if (            buf[2]==0x07 && buf[3]==0x7d) printf("(cancel)");
			if (            buf[2]==0x07 && buf[3]==0x7e) printf("(nak)");
			if (            buf[2]==0x07 && buf[3]==0x7f) printf("(ack)");
		}else if (          buf[2]==0x08) { printf("MIDI tuning");
			if (            buf[2]==0x08 && buf[3]==0x01) printf("(dump req)");
			if (            buf[2]==0x08 && buf[3]==0x02) printf("(dump)");
		}else if (          buf[2]==0x7b) printf("EOF");
		else  if (          buf[2]==0x7c) printf("wait");
		else  if (          buf[2]==0x7d) printf("cancel");
		else  if (          buf[2]==0x7e) printf("NAK");
		else  if (          buf[2]==0x7f) printf("ACK");
	}else if (buf[0]==0x7f){
		/*  device_id       sub_id_1     sub_id_2 */
		if (buf[1]==0x7f && buf[2]==4 && buf[3]==1)printf("master volume %d",buf[4]);
		else  if (          buf[2]==4 && buf[3]==2)printf("master balance %d",buf[4]);
		else  if (          buf[2]==1){ printf("MIDI time code");
			if (                         buf[3]==0x01) printf("(full message)");
			if (                         buf[3]==0x02) printf("(user bits)");
		}else if (          buf[2]==2)  printf("MIDI show control");
		else  if (          buf[2]==3){ printf("notation information");
			if (                         buf[3]==0x01) printf("(bar number)");
			if (                         buf[3]==0x02) printf("(time sig)");
		}else if (          buf[2]==4)printf("MIDI device control");
		else  if (          buf[2]==6)printf("MIDI machine control(command)");
		else  if (          buf[2]==7)printf("MIDI machine control(response)");
		else  if (          buf[2]==8)printf("MIDI tuning(retune)");
	}
	return c;
}
int f7_stat(int c, FILE *fp){
	int i,l;
	printf(" l=%d",c);l=c;
	for (i=0;i<l;++i) {
		c=byteread(fp); printf(" %2x",c);
		if (i<bufsiz) buf[i]=c;
	}
	if (buf[0]==0xf7) printf(" ;EOX");
	if (buf[0]==0xff) printf(" ;system reset");
	return c;
}
int meta_iv(int c, FILE *fp){
	/* oblomov: ^Cxg 0xff-x-len  len  MIDI ϒ\Ƃ */
	int t;
	unsigned long i, l;         /* oblomov */
	printf("t=x%2x",c);t=c;
	/* patch start */
	l = 0L;
	do {
		c = byteread(fp);
		l = (l << 7) + (unsigned long)(c & 0x7f);
	} while ((c & 0x80));
	printf(" l=x%2lx ",l);
	/* patch end */
	for (i=0;i<l;++i) {
		c=byteread(fp); if (i<bufsiz) buf[i]=c;
	}
	if (l<bufsiz) buf[l]=0; else buf[bufsiz-1]=0;
	switch(t){
	case 0:	  printf("seq_ptn=");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;/*l=2*/
	case 1:   printf("txt_dat=");printf("%s",buf);break;
	case 2:   printf("cpright=");printf("%s",buf);break;
	case 3:   printf("track_n=");printf("%s",buf);break;
	case 4:   printf("inst_nm=");printf("%s",buf);break;
	case 5:   printf("lyric  =");printf("%s",buf);break;
	case 6:   printf("marker =");printf("%s",buf);break;
	case 7:   printf("cue_pnt=");printf("%s",buf);break;
	case 8:   printf("undefin=");printf("%s",buf);break;
	case 0x20:printf("channel=");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;/*l=1*/
	case 0x21:printf("port_No=");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;
	case 0x2f:printf("endtrack");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;/*l=0*/
	case 0x51:printf("tempo  =");for (i=0;i<l;++i) printf(" %2x",buf[i]);      /*l=3*/
	{
		long tempo=(long)buf[0]*65536L+(long)buf[1]*256L+(long)buf[2];
		printf(" (%ld) MM=%f", tempo, 60.0*1000000.0/(double)tempo);
	}break;
	case 0x54:printf("smpte  =");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;/*l=5*/
	case 0x58:printf("beat   =");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;/*l=4*/
	case 0x59:printf("scale  =");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;/*l=2*/
	case 0x7f:printf("original");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;
	default:  printf("other  =");for (i=0;i<l;++i) printf(" %2x",buf[i]);break;
	}
	return c;
}

void header_print(FILE *fp,int mode){
	int i;
	if (fread(buf,4,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
	if (strncmp((char*)buf,"RIFF",4)==0){
		puts("RIFF format");
		if (fread(buf,8,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
		len=(long)buf[0]+(long)buf[1]*256L+(long)buf[2]*256L*256L+(long)buf[3]*256L*256L*256L;
		printf("chunk size=%ld:",len);
		for (i=0;i<4;++i) printf(" %2x",buf[i]); printf("\n");
		printf("form  type=");
		for (i=4;i<8;++i) printf("%c",buf[i]); printf("\n");

		if (fread(buf,8,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
		printf("chunk ID=");
		for (i=0;i<4;++i) printf("%c",buf[i]); printf("\n");
		len=(long)buf[4]+(long)buf[5]*256L+(long)buf[6]*256L*256L+(long)buf[7]*256L*256L*256L;
		printf("chunk size=%ld:",len);
		for (i=4;i<8;++i) printf(" %2x",buf[i]); printf("\n");
		if (fread(buf,4,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
	}
	if (strncmp((char*)buf,"MThd",4)!=0)
		puts("mid2txt:this file is not midi file"),fclose(fp),exit(1);
	puts("standard MIDI file");
	if (fread(buf,4,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
	len=buf[3];
	printf("header length=%ld\n", len);
	if (len<6)printf("header errer");
	if (fread(buf,len,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
	printf("format  =%d\n",buf[1]);
	printf("track   =%d\n",buf[3]);
	maxtrk=buf[3];
	printf("division=%d\n",buf[5]+buf[4]*256);
	if (mode==0) puts("mode    =delta time");
	else         puts("mode    =total time");
	for(i=6;i<len;++i) printf("%2x",buf[i]);
	printf("\n----------\n");
}

void body_print(FILE *fp, int mode){
	int c, cb;
	long total;
	trk=0;
	setjmp(jmpbuf);
	if (fread(buf,4,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
	if (strncmp((char*)buf,"MTrk",4)!=0){
		buf[4]=0; puts((char*)buf);
		puts("mid2txt:this file is not midi file"),fclose(fp),exit(1);
	}
	printf("track %d",trk);
	if (fread(buf,4,1,fp)==0)puts("mid2txt:can't read"),fclose(fp),exit(1);
	len=(long)buf[3]+(long)buf[2]*256L+(long)buf[1]*256L*256L+(long)buf[0]*256L*256L*256L;
	printf(" data length=%ld\n", len);
	cnt=0; c=cb=0; total=0;
	do{
		long t=0;/* k=128 */
		do{
			c=byteread(fp);if(c==EOF)break;
			t = t * 128 + (c & 0x7f);
		}while( (c&0x80)==0x80 );
		if (c==EOF) break;
		total += t;
		if (mode==0) printf("%9ld ",t);
		else         printf("%9ld ",total);

		c = byteread(fp);
		if (0x80 <= c && c !=0xFF) cb=c; /* ^CxgO */
		if (0x80 <= c && c < 0xf0) printf("ch=%x ",c&0x0f);
		if ((c&0xf0)==0x80){                       /* note off */
			printf("n_off");
			c=byteread(fp);
			c=note_on(c,fp);
		}else if ((c&0xf0)==0x90){                 /* note on  */
			int k;
			printf("nt_on");
			k=c=byteread(fp);
			c=note_on(c,fp);
			if ((cb&0x0f)==9 && 27<=k && k<109) printf(" %s",drums[k-27]);
		}else if ((c&0xf0)==0xA0){                 /* poly key pressure */
			printf("after");
			c=byteread(fp);
			c=note_on(c,fp);
		}else if ((c&0xf0)==0xB0){                 /* control change */
			printf("contc");
			c=byteread(fp);
			c=cont_ch(c,fp);
		}else if ((c&0xf0)==0xC0){                 /* program change */
			printf("progc");
			c=byteread(fp);
			c=prog_ch(c,fp);
		}else if ((c&0xf0)==0xD0){                 /* channel pressure */
			printf("c_prs");
			c=byteread(fp);
			c=ch_pres(c,fp);
		}else if ((c&0xf0)==0xE0){                 /* pitch bend */
			printf("pitch");
			c=byteread(fp);
			c=pitch_b(c,fp);
		}else if (c==0xF0){
			int l=0;
			printf("F0_sts");
			do {
				c = byteread(fp);
				l = (l << 7) + (c & 0x7f);
			} while ((c & 0x80));
			c=f0_stat(l,fp);
		}else if (c==0xF1){
			printf("ڰү");
			c=byteread(fp);printf(" x%2x",c);
		}else if (c==0xF2){
			printf("ݸ߼޼߲");
			c=byteread(fp);printf(" x%2x",c);
			c=byteread(fp);printf(" x%2x",c);
		}else if (c==0xF3){
			printf("ݸ޾ڸ");
			c=byteread(fp);printf(" x%2x",c);
		}else if (c==0xF4){
			printf("`");
		}else if (c==0xF5){
			printf("partch"); /* sc88 & mu80 */
			c=byteread(fp);
			printf(" c=%d",c);
		}else if (c==0xF6){
			printf("ظ");
		}else if (c==0xF7){
			int l=0;
			printf("F7_sts");
			do {
				c = byteread(fp);
				l = (l << 7) + (c & 0x7f);
			} while ((c & 0x80));
			c=f7_stat(l,fp);
		}else if (c==0xF8){
			printf("ݸ޸ۯ");
		}else if (c==0xF9){
			printf("`");
		}else if (c==0xFA){
			printf("start");
		}else if (c==0xFB){
			printf("continue");
		}else if (c==0xFC){
			printf("stop");
		}else if (c==0xFD){
			printf("`");
		}else if (c==0xFE){
			printf("è޾ݼݸ(gm)");
		}else if (c==0xFF){
			printf("meta ");
			c=byteread(fp);
			c=meta_iv(c,fp);
		}else{
			if (0x80 <= cb && cb < 0xf0) printf("ch=%x -----",cb & 0x0f);
			else printf("---- -----");
			if ((cb&0xf0)==0x80)      c=note_on(c,fp);   /* note off */
			else if ((cb&0xf0)==0x90) {
				int k=c;
				c=note_on(c,fp);
				if ((cb&0x0f)==9 && 27<=k && k<109) printf(" %s",drums[k-27]);
			}else if ((cb&0xf0)==0xA0) c=note_on(c,fp);  /* poly key pressure */
			else if ((cb&0xf0)==0xB0) c=cont_ch(c,fp);
			else if ((cb&0xf0)==0xC0) c=prog_ch(c,fp);
			else if ((cb&0xf0)==0xD0) c=ch_pres(c,fp);
			else if ((cb&0xf0)==0xE0) c=pitch_b(c,fp);
			else if (cb==0xF5)        printf(" c=%d",c); /* sc88 & mu80 */
			else if (cb==0xFF)        c=meta_iv(c,fp);
			/* else if (cb==0xF0)        c=f0_stat(c,fp); */
			/* else if (cb==0xF7)        c=f7_stat(c,fp); */
			else  printf("running status error %x",c);
		}/*endif*/
		printf("\n");
	}while(c!=EOF);
}

void usage(void){
	puts("usage:mid2txt [/t or /d] infile.mid");
	puts("      /t : total time          ");
	puts("      /d : delta time (default)");
	exit(1);
}

int main(int argc, char **argv){
	FILE *fp; int mode=0;
	if (argc==3){
		if      (argv[1][0]=='/' && argv[1][1]=='t')mode=1;
		else if (argv[1][0]=='/' && argv[1][1]=='d')mode=0;
		else usage();
	}else if (argc!=2) usage();
	printf("filename=%s\n",argv[argc-1]);
	if ((fp=fopen(argv[argc-1],"rb"))==NULL)puts("mid2txt:can't open"),exit(1);
	header_print(fp,mode);
	body_print(fp,mode);
	if (fclose(fp)!=0)puts("mid2txt:can't close"),exit(1);
	return 0;
}
